/*
 *      dxtabitem.h
 *
 *      Copyright 2014 David Vachulka <arch_dvx@users.sourceforge.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */


#ifndef DXTABITEM_H
#define DXTABITEM_H

#include <QtGui>
#if(QT_VERSION > 0x050000)
#include <QtWidgets>
#endif
#include "defs.h"
#include "tabwidget.h"

class dxirc;

class dxTabItem: public QWidget
{
    Q_OBJECT
friend class dxirc;
public:
    dxTabItem(TabWidget *tabbook, int id = 0, QWidget *parent = 0);
    virtual ~dxTabItem();

    virtual void clearChat() {}
    virtual void hideUsers() {}
    virtual void showUsers() {}
    virtual QString getServerName() { return ""; }
    virtual QString getRealServerName() { return ""; }
    virtual int getServerPort() { return 0; }
    virtual QString getNickName() { return "";}
    virtual void setType(const TYPE &typ, const QString &name) {}
    virtual TYPE getType() { return OTHER; }
    int getID() { return m_id; }
    virtual void preferencesUpdated() {}
    virtual void setCommandFocus() {}
    virtual void showSpellComboUpdated() {}
    virtual void makeLastRowVisible() {}
    virtual QString getSpellLang() {return ""; }
    virtual QString getTabName() { return ""; }
protected:
    dxTabItem(){}
    
    TabWidget *m_tabbook;

    virtual void appendText(QString msg, bool highlight, bool logLine=true) {}
    virtual void appendStyledText(QString text, int style, bool highlight, bool disableStrip=false, bool logLine=true) {}
    virtual bool processLine(const QString &) { return false; }
    virtual void setHasAllCommand(bool) {}
    virtual void setHasOwnMsg(bool) {}
    bool isCurrent();
private:
    int m_id;
};

#endif // DXTABITEM_H
